Trending: new daily set
[csit.git] / resources / libraries / bash / function / common.sh
1 # Copyright (c) 2019 Cisco and/or its affiliates.
2 # Copyright (c) 2019 PANTHEON.tech and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at:
6 #
7 #     http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14
15 set -exuo pipefail
16
17 # This library defines functions used by multiple entry scripts.
18 # Keep functions ordered alphabetically, please.
19
20 # TODO: Add a link to bash style guide.
21 # TODO: Consider putting every die into a {} block,
22 #   the code might become more readable (but longer).
23
24
25 function activate_docker_topology () {
26
27     # Create virtual vpp-device topology. Output of the function is topology
28     # file describing created environment saved to a file.
29     #
30     # Variables read:
31     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
32     # - TOPOLOGIES - Available topologies.
33     # - NODENESS - Node multiplicity of desired testbed.
34     # - FLAVOR - Node flavor string, usually describing the processor.
35     # - IMAGE_VER_FILE - Name of file that contains the image version.
36     # - CSIT_DIR - Directory where ${IMAGE_VER_FILE} is located.
37     # Variables set:
38     # - WORKING_TOPOLOGY - Path to topology file.
39
40     set -exuo pipefail
41
42     source "${BASH_FUNCTION_DIR}/device.sh" || {
43         die "Source failed!"
44     }
45
46     device_image="$(< ${CSIT_DIR}/${IMAGE_VER_FILE})"
47     case_text="${NODENESS}_${FLAVOR}"
48     case "${case_text}" in
49         "1n_skx" | "1n_tx2")
50             # We execute reservation over csit-shim-dcr (ssh) which runs sourced
51             # script's functions. Env variables are read from ssh output
52             # back to localhost for further processing.
53             hostname=$(grep search /etc/resolv.conf | cut -d' ' -f3) || die
54             ssh="ssh root@${hostname} -p 6022"
55             run="activate_wrapper ${NODENESS} ${FLAVOR} ${device_image}"
56             # The "declare -f" output is long and boring.
57             set +x
58             # backtics to avoid https://midnight-commander.org/ticket/2142
59             env_vars=`${ssh} "$(declare -f); ${run}"` || {
60                 die "Topology reservation via shim-dcr failed!"
61             }
62             set -x
63             set -a
64             source <(echo "$env_vars" | grep -v /usr/bin/docker) || {
65                 die "Source failed!"
66             }
67             set +a
68             ;;
69         "1n_vbox")
70             # We execute reservation on localhost. Sourced script automatially
71             # sets environment variables for further processing.
72             activate_wrapper "${NODENESS}" "${FLAVOR}" "${device_image}" || die
73             ;;
74         *)
75             die "Unknown specification: ${case_text}!"
76     esac
77
78     trap 'deactivate_docker_topology' EXIT || {
79          die "Trap attempt failed, please cleanup manually. Aborting!"
80     }
81
82     # Replace all variables in template with those in environment.
83     source <(echo 'cat <<EOF >topo.yml'; cat ${TOPOLOGIES[0]}; echo EOF;) || {
84         die "Topology file create failed!"
85     }
86
87     WORKING_TOPOLOGY="/tmp/topology.yaml"
88     mv topo.yml "${WORKING_TOPOLOGY}" || {
89         die "Topology move failed!"
90     }
91     cat ${WORKING_TOPOLOGY} | grep -v password || {
92         die "Topology read failed!"
93     }
94 }
95
96
97 function activate_virtualenv () {
98
99     # Update virtualenv pip package, delete and create virtualenv directory,
100     # activate the virtualenv, install requirements, set PYTHONPATH.
101
102     # Arguments:
103     # - ${1} - Path to existing directory for creating virtualenv in.
104     #          If missing or empty, ${CSIT_DIR} is used.
105     # - ${2} - Path to requirements file, ${CSIT_DIR}/requirements.txt if empty.
106     # Variables read:
107     # - CSIT_DIR - Path to existing root of local CSIT git repository.
108     # Variables exported:
109     # - PYTHONPATH - CSIT_DIR, as CSIT Python scripts usually need this.
110     # Functions called:
111     # - die - Print to stderr and exit.
112
113     set -exuo pipefail
114
115     root_path="${1-$CSIT_DIR}"
116     env_dir="${root_path}/env"
117     req_path=${2-$CSIT_DIR/requirements.txt}
118     rm -rf "${env_dir}" || die "Failed to clean previous virtualenv."
119     pip3 install --upgrade virtualenv || {
120         die "Virtualenv package install failed."
121     }
122     virtualenv --python=$(which python3) "${env_dir}" || {
123         die "Virtualenv creation for $(which python3) failed."
124     }
125     set +u
126     source "${env_dir}/bin/activate" || die "Virtualenv activation failed."
127     set -u
128     pip3 install --upgrade -r "${req_path}" || {
129         die "Requirements installation failed."
130     }
131     # Most CSIT Python scripts assume PYTHONPATH is set and exported.
132     export PYTHONPATH="${CSIT_DIR}" || die "Export failed."
133 }
134
135
136 function archive_tests () {
137
138     # Create .tar.xz of generated/tests for archiving.
139     # To be run after generate_tests, kept separate to offer more flexibility.
140
141     # Directory read:
142     # - ${GENERATED_DIR}/tests - Tree of executed suites to archive.
143     # File rewriten:
144     # - ${ARCHIVE_DIR}/tests.tar.xz - Archive of generated tests.
145
146     set -exuo pipefail
147
148     tar c "${GENERATED_DIR}/tests" | xz -9e > "${ARCHIVE_DIR}/tests.tar.xz" || {
149         die "Error creating archive of generated tests."
150     }
151 }
152
153
154 function check_download_dir () {
155
156     # Fail if there are no files visible in ${DOWNLOAD_DIR}.
157     #
158     # Variables read:
159     # - DOWNLOAD_DIR - Path to directory pybot takes the build to test from.
160     # Directories read:
161     # - ${DOWNLOAD_DIR} - Has to be non-empty to proceed.
162     # Functions called:
163     # - die - Print to stderr and exit.
164
165     set -exuo pipefail
166
167     if [[ ! "$(ls -A "${DOWNLOAD_DIR}")" ]]; then
168         die "No artifacts downloaded!"
169     fi
170 }
171
172
173 function check_prerequisites () {
174
175     # Fail if prerequisites are not met.
176     #
177     # Functions called:
178     # - installed - Check if application is installed/present in system.
179     # - die - Print to stderr and exit.
180
181     set -exuo pipefail
182
183     if ! installed sshpass; then
184         die "Please install sshpass before continue!"
185     fi
186 }
187
188
189 function common_dirs () {
190
191     # Set global variables, create some directories (without touching content).
192
193     # Variables set:
194     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
195     # - CSIT_DIR - Path to existing root of local CSIT git repository.
196     # - TOPOLOGIES_DIR - Path to existing directory with available tpologies.
197     # - RESOURCES_DIR - Path to existing CSIT subdirectory "resources".
198     # - TOOLS_DIR - Path to existing resources subdirectory "tools".
199     # - PYTHON_SCRIPTS_DIR - Path to existing tools subdirectory "scripts".
200     # - ARCHIVE_DIR - Path to created CSIT subdirectory "archive".
201     # - DOWNLOAD_DIR - Path to created CSIT subdirectory "download_dir".
202     # - GENERATED_DIR - Path to created CSIT subdirectory "generated".
203     # Directories created if not present:
204     # ARCHIVE_DIR, DOWNLOAD_DIR, GENERATED_DIR.
205     # Functions called:
206     # - die - Print to stderr and exit.
207
208     set -exuo pipefail
209
210     this_file=$(readlink -e "${BASH_SOURCE[0]}") || {
211         die "Some error during locating of this source file."
212     }
213     BASH_FUNCTION_DIR=$(dirname "${this_file}") || {
214         die "Some error during dirname call."
215     }
216     # Current working directory could be in a different repo, e.g. VPP.
217     pushd "${BASH_FUNCTION_DIR}" || die "Pushd failed"
218     relative_csit_dir=$(git rev-parse --show-toplevel) || {
219         die "Git rev-parse failed."
220     }
221     CSIT_DIR=$(readlink -e "${relative_csit_dir}") || die "Readlink failed."
222     popd || die "Popd failed."
223     TOPOLOGIES_DIR=$(readlink -e "${CSIT_DIR}/topologies/available") || {
224         die "Readlink failed."
225     }
226     RESOURCES_DIR=$(readlink -e "${CSIT_DIR}/resources") || {
227         die "Readlink failed."
228     }
229     TOOLS_DIR=$(readlink -e "${RESOURCES_DIR}/tools") || {
230         die "Readlink failed."
231     }
232     DOC_GEN_DIR=$(readlink -e "${TOOLS_DIR}/doc_gen") || {
233         die "Readlink failed."
234     }
235     PYTHON_SCRIPTS_DIR=$(readlink -e "${TOOLS_DIR}/scripts") || {
236         die "Readlink failed."
237     }
238
239     ARCHIVE_DIR=$(readlink -f "${CSIT_DIR}/archive") || {
240         die "Readlink failed."
241     }
242     mkdir -p "${ARCHIVE_DIR}" || die "Mkdir failed."
243     DOWNLOAD_DIR=$(readlink -f "${CSIT_DIR}/download_dir") || {
244         die "Readlink failed."
245     }
246     mkdir -p "${DOWNLOAD_DIR}" || die "Mkdir failed."
247     GENERATED_DIR=$(readlink -f "${CSIT_DIR}/generated") || {
248         die "Readlink failed."
249     }
250     mkdir -p "${GENERATED_DIR}" || die "Mkdir failed."
251 }
252
253
254 function compose_pybot_arguments () {
255
256     # Variables read:
257     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
258     # - DUT - CSIT test/ subdirectory, set while processing tags.
259     # - TAGS - Array variable holding selected tag boolean expressions.
260     # - TOPOLOGIES_TAGS - Tag boolean expression filtering tests for topology.
261     # - TEST_CODE - The test selection string from environment or argument.
262     # Variables set:
263     # - PYBOT_ARGS - String holding part of all arguments for pybot.
264     # - EXPANDED_TAGS - Array of strings pybot arguments compiled from tags.
265
266     set -exuo pipefail
267
268     # No explicit check needed with "set -u".
269     PYBOT_ARGS=("--loglevel" "TRACE")
270     PYBOT_ARGS+=("--variable" "TOPOLOGY_PATH:${WORKING_TOPOLOGY}")
271
272     case "${TEST_CODE}" in
273         *"device"*)
274             PYBOT_ARGS+=("--suite" "tests.${DUT}.device")
275             ;;
276         *"func"*)
277             PYBOT_ARGS+=("--suite" "tests.${DUT}.func")
278             ;;
279         *"perf"*)
280             PYBOT_ARGS+=("--suite" "tests.${DUT}.perf")
281             ;;
282         *)
283             die "Unknown specification: ${TEST_CODE}"
284     esac
285
286     EXPANDED_TAGS=()
287     for tag in "${TAGS[@]}"; do
288         if [[ ${tag} == "!"* ]]; then
289             EXPANDED_TAGS+=("--exclude" "${tag#$"!"}")
290         else
291             EXPANDED_TAGS+=("--include" "${TOPOLOGIES_TAGS}AND${tag}")
292         fi
293     done
294 }
295
296
297 function copy_archives () {
298
299     # Create additional archive if workspace variable is set.
300     # This way if script is running in jenkins all will be
301     # automatically archived to logs.fd.io.
302     #
303     # Variables read:
304     # - WORKSPACE - Jenkins workspace, copy only if the value is not empty.
305     #   Can be unset, then it speeds up manual testing.
306     # - ARCHIVE_DIR - Path to directory with content to be copied.
307     # Directories updated:
308     # - ${WORKSPACE}/archives/ - Created if does not exist.
309     #   Content of ${ARCHIVE_DIR}/ is copied here.
310     # Functions called:
311     # - die - Print to stderr and exit.
312
313     set -exuo pipefail
314
315     if [[ -n "${WORKSPACE-}" ]]; then
316         mkdir -p "${WORKSPACE}/archives/" || die "Archives dir create failed."
317         cp -rf "${ARCHIVE_DIR}"/* "${WORKSPACE}/archives" || die "Copy failed."
318     fi
319 }
320
321
322 function deactivate_docker_topology () {
323
324     # Deactivate virtual vpp-device topology by removing containers.
325     #
326     # Variables read:
327     # - NODENESS - Node multiplicity of desired testbed.
328     # - FLAVOR - Node flavor string, usually describing the processor.
329
330     set -exuo pipefail
331
332     case_text="${NODENESS}_${FLAVOR}"
333     case "${case_text}" in
334         "1n_skx" | "1n_tx2")
335             hostname=$(grep search /etc/resolv.conf | cut -d' ' -f3) || die
336             ssh="ssh root@${hostname} -p 6022"
337             env_vars=$(env | grep CSIT_ | tr '\n' ' ' ) || die
338             # The "declare -f" output is long and boring.
339             set +x
340             ${ssh} "$(declare -f); deactivate_wrapper ${env_vars}" || {
341                 die "Topology cleanup via shim-dcr failed!"
342             }
343             set -x
344             ;;
345         "1n_vbox")
346             enter_mutex || die
347             clean_environment || {
348                 die "Topology cleanup locally failed!"
349             }
350             exit_mutex || die
351             ;;
352         *)
353             die "Unknown specification: ${case_text}!"
354     esac
355 }
356
357
358 function die () {
359
360     # Print the message to standard error end exit with error code specified
361     # by the second argument.
362     #
363     # Hardcoded values:
364     # - The default error message.
365     # Arguments:
366     # - ${1} - The whole error message, be sure to quote. Optional
367     # - ${2} - the code to exit with, default: 1.
368
369     set -x
370     set +eu
371     warn "${1:-Unspecified run-time error occurred!}"
372     exit "${2:-1}"
373 }
374
375
376 function die_on_pybot_error () {
377
378     # Source this fragment if you want to abort on any failed test case.
379     #
380     # Variables read:
381     # - PYBOT_EXIT_STATUS - Set by a pybot running fragment.
382     # Functions called:
383     # - die - Print to stderr and exit.
384
385     set -exuo pipefail
386
387     if [[ "${PYBOT_EXIT_STATUS}" != "0" ]]; then
388         die "Test failures are present!" "${PYBOT_EXIT_STATUS}"
389     fi
390 }
391
392
393 function generate_tests () {
394
395     # Populate ${GENERATED_DIR}/tests based on ${CSIT_DIR}/tests/.
396     # Any previously existing content of ${GENERATED_DIR}/tests is wiped before.
397     # The generation is done by executing any *.py executable
398     # within any subdirectory after copying.
399
400     # This is a separate function, because this code is called
401     # both by autogen checker and entries calling run_pybot.
402
403     # Directories read:
404     # - ${CSIT_DIR}/tests - Used as templates for the generated tests.
405     # Directories replaced:
406     # - ${GENERATED_DIR}/tests - Overwritten by the generated tests.
407
408     set -exuo pipefail
409
410     rm -rf "${GENERATED_DIR}/tests" || die
411     cp -r "${CSIT_DIR}/tests" "${GENERATED_DIR}/tests" || die
412     cmd_line=("find" "${GENERATED_DIR}/tests" "-type" "f")
413     cmd_line+=("-executable" "-name" "*.py")
414     file_list=$("${cmd_line[@]}") || die
415
416     for gen in ${file_list}; do
417         directory="$(dirname "${gen}")" || die
418         filename="$(basename "${gen}")" || die
419         pushd "${directory}" || die
420         ./"${filename}" || die
421         popd || die
422     done
423 }
424
425
426 function get_test_code () {
427
428     # Arguments:
429     # - ${1} - Optional, argument of entry script (or empty as unset).
430     #   Test code value to override job name from environment.
431     # Variables read:
432     # - JOB_NAME - String affecting test selection, default if not argument.
433     # Variables set:
434     # - TEST_CODE - The test selection string from environment or argument.
435     # - NODENESS - Node multiplicity of desired testbed.
436     # - FLAVOR - Node flavor string, usually describing the processor.
437
438     set -exuo pipefail
439
440     TEST_CODE="${1-}" || die "Reading optional argument failed, somehow."
441     if [[ -z "${TEST_CODE}" ]]; then
442         TEST_CODE="${JOB_NAME-}" || die "Reading job name failed, somehow."
443     fi
444
445     case "${TEST_CODE}" in
446         *"1n-vbox"*)
447             NODENESS="1n"
448             FLAVOR="vbox"
449             ;;
450         *"1n-skx"*)
451             NODENESS="1n"
452             FLAVOR="skx"
453             ;;
454        *"1n-tx2"*)
455             NODENESS="1n"
456             FLAVOR="tx2"
457             ;;
458         *"2n-skx"*)
459             NODENESS="2n"
460             FLAVOR="skx"
461             ;;
462         *"3n-skx"*)
463             NODENESS="3n"
464             FLAVOR="skx"
465             ;;
466         *"2n-clx"*)
467             NODENESS="2n"
468             FLAVOR="clx"
469             ;;
470         *"2n-dnv"*)
471             NODENESS="2n"
472             FLAVOR="dnv"
473             ;;
474         *"3n-dnv"*)
475             NODENESS="3n"
476             FLAVOR="dnv"
477             ;;
478         *"3n-tsh"*)
479             NODENESS="3n"
480             FLAVOR="tsh"
481             ;;
482         *)
483             # Fallback to 3-node Haswell by default (backward compatibility)
484             NODENESS="3n"
485             FLAVOR="hsw"
486             ;;
487     esac
488 }
489
490
491 function get_test_tag_string () {
492
493     # Variables read:
494     # - GERRIT_EVENT_TYPE - Event type set by gerrit, can be unset.
495     # - GERRIT_EVENT_COMMENT_TEXT - Comment text, read for "comment-added" type.
496     # - TEST_CODE - The test selection string from environment or argument.
497     # Variables set:
498     # - TEST_TAG_STRING - The string following trigger word in gerrit comment.
499     #   May be empty, or even not set on event types not adding comment.
500
501     # TODO: ci-management scripts no longer need to perform this.
502
503     set -exuo pipefail
504
505     if [[ "${GERRIT_EVENT_TYPE-}" == "comment-added" ]]; then
506         case "${TEST_CODE}" in
507             *"device"*)
508                 trigger="devicetest"
509                 ;;
510             *"perf"*)
511                 trigger="perftest"
512                 ;;
513             *)
514                 die "Unknown specification: ${TEST_CODE}"
515         esac
516         # Ignore lines not containing the trigger word.
517         comment=$(fgrep "${trigger}" <<< "${GERRIT_EVENT_COMMENT_TEXT}") || true
518         # The vpp-csit triggers trail stuff we are not interested in.
519         # Removing them and trigger word: https://unix.stackexchange.com/a/13472
520         # (except relying on \s whitespace, \S non-whitespace and . both).
521         # The last string is concatenated, only the middle part is expanded.
522         cmd=("grep" "-oP" '\S*'"${trigger}"'\S*\s\K.+$') || die "Unset trigger?"
523         # On parsing error, TEST_TAG_STRING probably stays empty.
524         TEST_TAG_STRING=$("${cmd[@]}" <<< "${comment}") || true
525     fi
526 }
527
528
529 function installed () {
530
531     # Check if the given utility is installed. Fail if not installed.
532     #
533     # Duplicate of common.sh function, as this file is also used standalone.
534     #
535     # Arguments:
536     # - ${1} - Utility to check.
537     # Returns:
538     # - 0 - If command is installed.
539     # - 1 - If command is not installed.
540
541     set -exuo pipefail
542
543     command -v "${1}"
544 }
545
546
547 function reserve_and_cleanup_testbed () {
548
549     # Reserve physical testbed, perform cleanup, register trap to unreserve.
550     # When cleanup fails, remove from topologies and keep retrying
551     # until all topologies are removed.
552     #
553     # Variables read:
554     # - TOPOLOGIES - Array of paths to topology yaml to attempt reservation on.
555     # - PYTHON_SCRIPTS_DIR - Path to directory holding the reservation script.
556     # - BUILD_TAG - Any string suitable as filename, identifying
557     #   test run executing this function. May be unset.
558     # Variables set:
559     # - TOPOLOGIES - Array of paths to topologies, with failed cleanups removed.
560     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
561     # Functions called:
562     # - die - Print to stderr and exit.
563     # - ansible_hosts - Perform an action using ansible, see ansible.sh
564     # Traps registered:
565     # - EXIT - Calls cancel_all for ${WORKING_TOPOLOGY}.
566
567     set -exuo pipefail
568
569     while true; do
570         for topo in "${TOPOLOGIES[@]}"; do
571             set +e
572             scrpt="${PYTHON_SCRIPTS_DIR}/topo_reservation.py"
573             opts=("-t" "${topo}" "-r" "${BUILD_TAG:-Unknown}")
574             python3 "${scrpt}" "${opts[@]}"
575             result="$?"
576             set -e
577             if [[ "${result}" == "0" ]]; then
578                 # Trap unreservation before cleanup check,
579                 # so multiple jobs showing failed cleanup improve chances
580                 # of humans to notice and fix.
581                 WORKING_TOPOLOGY="${topo}"
582                 echo "Reserved: ${WORKING_TOPOLOGY}"
583                 trap "untrap_and_unreserve_testbed" EXIT || {
584                     message="TRAP ATTEMPT AND UNRESERVE FAILED, FIX MANUALLY."
585                     untrap_and_unreserve_testbed "${message}" || {
586                         die "Teardown should have died, not failed."
587                     }
588                     die "Trap attempt failed, unreserve succeeded. Aborting."
589                 }
590                 # Cleanup check.
591                 set +e
592                 ansible_hosts "cleanup"
593                 result="$?"
594                 set -e
595                 if [[ "${result}" == "0" ]]; then
596                     break
597                 fi
598                 warn "Testbed cleanup failed: ${topo}"
599                 untrap_and_unreserve_testbed "Fail of unreserve after cleanup."
600             fi
601             # Else testbed is accessible but currently reserved, moving on.
602         done
603
604         if [[ -n "${WORKING_TOPOLOGY-}" ]]; then
605             # Exit the infinite while loop if we made a reservation.
606             warn "Reservation and cleanup successful."
607             break
608         fi
609
610         if [[ "${#TOPOLOGIES[@]}" == "0" ]]; then
611             die "Run out of operational testbeds!"
612         fi
613
614         # Wait ~3minutes before next try.
615         sleep_time="$[ ( ${RANDOM} % 20 ) + 180 ]s" || {
616             die "Sleep time calculation failed."
617         }
618         echo "Sleeping ${sleep_time}"
619         sleep "${sleep_time}" || die "Sleep failed."
620     done
621 }
622
623
624 function run_pybot () {
625
626     # Run pybot with options based on input variables. Create output_info.xml
627     #
628     # Variables read:
629     # - CSIT_DIR - Path to existing root of local CSIT git repository.
630     # - ARCHIVE_DIR - Path to store robot result files in.
631     # - PYBOT_ARGS, EXPANDED_TAGS - See compose_pybot_arguments.sh
632     # - GENERATED_DIR - Tests are assumed to be generated under there.
633     # Variables set:
634     # - PYBOT_EXIT_STATUS - Exit status of most recent pybot invocation.
635     # Functions called:
636     # - die - Print to stderr and exit.
637
638     set -exuo pipefail
639
640     all_options=("--outputdir" "${ARCHIVE_DIR}" "${PYBOT_ARGS[@]}")
641     all_options+=("--noncritical" "EXPECTED_FAILING")
642     all_options+=("${EXPANDED_TAGS[@]}")
643
644     pushd "${CSIT_DIR}" || die "Change directory operation failed."
645     set +e
646     robot "${all_options[@]}" "${GENERATED_DIR}/tests/"
647     PYBOT_EXIT_STATUS="$?"
648     set -e
649
650     # Generate INFO level output_info.xml for post-processing.
651     all_options=("--loglevel" "INFO")
652     all_options+=("--log" "none")
653     all_options+=("--report" "none")
654     all_options+=("--output" "${ARCHIVE_DIR}/output_info.xml")
655     all_options+=("${ARCHIVE_DIR}/output.xml")
656     rebot "${all_options[@]}" || true
657     popd || die "Change directory operation failed."
658 }
659
660
661 function select_arch_os () {
662
663     # Set variables affected by local CPU architecture and operating system.
664     #
665     # Variables set:
666     # - VPP_VER_FILE - Name of file in CSIT dir containing vpp stable version.
667     # - IMAGE_VER_FILE - Name of file in CSIT dir containing the image name.
668     # - PKG_SUFFIX - Suffix of OS package file name, "rpm" or "deb."
669
670     set -exuo pipefail
671
672     os_id=$(grep '^ID=' /etc/os-release | cut -f2- -d= | sed -e 's/\"//g') || {
673         die "Get OS release failed."
674     }
675
676     case "${os_id}" in
677         "ubuntu"*)
678             IMAGE_VER_FILE="VPP_DEVICE_IMAGE_UBUNTU"
679             VPP_VER_FILE="VPP_STABLE_VER_UBUNTU_BIONIC"
680             PKG_SUFFIX="deb"
681             ;;
682         "centos"*)
683             IMAGE_VER_FILE="VPP_DEVICE_IMAGE_CENTOS"
684             VPP_VER_FILE="VPP_STABLE_VER_CENTOS"
685             PKG_SUFFIX="rpm"
686             ;;
687         *)
688             die "Unable to identify distro or os from ${os_id}"
689             ;;
690     esac
691
692     arch=$(uname -m) || {
693         die "Get CPU architecture failed."
694     }
695
696     case "${arch}" in
697         "aarch64")
698             IMAGE_VER_FILE="${IMAGE_VER_FILE}_ARM"
699             ;;
700         *)
701             ;;
702     esac
703 }
704
705
706 function select_tags () {
707
708     # Variables read:
709     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
710     # - TEST_CODE - String affecting test selection, usually jenkins job name.
711     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
712     #   Can be unset.
713     # - TOPOLOGIES_DIR - Path to existing directory with available tpologies.
714     # - BASH_FUNCTION_DIR - Directory with input files to process.
715     # Variables set:
716     # - TAGS - Array of processed tag boolean expressions.
717
718     set -exuo pipefail
719
720     # NIC SELECTION
721     start_pattern='^  TG:'
722     end_pattern='^ \? \?[A-Za-z0-9]\+:'
723     # Remove the TG section from topology file
724     sed_command="/${start_pattern}/,/${end_pattern}/d"
725     # All topologies DUT NICs
726     available=$(sed "${sed_command}" "${TOPOLOGIES_DIR}"/* \
727                 | grep -hoP "model: \K.*" | sort -u)
728     # Selected topology DUT NICs
729     reserved=$(sed "${sed_command}" "${WORKING_TOPOLOGY}" \
730                | grep -hoP "model: \K.*" | sort -u)
731     # All topologies DUT NICs - Selected topology DUT NICs
732     exclude_nics=($(comm -13 <(echo "${reserved}") <(echo "${available}"))) || {
733         die "Computation of excluded NICs failed."
734     }
735
736     # Select default NIC tag.
737     case "${TEST_CODE}" in
738         *"3n-dnv"* | *"2n-dnv"*)
739             default_nic="nic_intel-x553"
740             ;;
741         *"3n-tsh"*)
742             default_nic="nic_intel-x520-da2"
743             ;;
744         *"3n-skx"* | *"2n-skx"* | *"2n-clx"*)
745             default_nic="nic_intel-xxv710"
746             ;;
747         *"3n-hsw"* | *"mrr-daily-master")
748             default_nic="nic_intel-xl710"
749             ;;
750         *)
751             default_nic="nic_intel-x710"
752             ;;
753     esac
754
755     sed_nic_sub_cmd="sed s/\${default_nic}/${default_nic}/"
756     sed_nics_sub_cmd="sed -e s/ANDxxv710/ANDnic_intel-xxv710/"
757     sed_nics_sub_cmd+=" | sed -e s/ANDx710/ANDnic_intel-x710/"
758     sed_nics_sub_cmd+=" | sed -e s/ANDxl710/ANDnic_intel-xl710/"
759     sed_nics_sub_cmd+=" | sed -e s/ANDx520-da2/ANDnic_intel-x520-da2/"
760     sed_nics_sub_cmd+=" | sed -e s/ANDx553/ANDnic_intel-x553/"
761     sed_nics_sub_cmd+=" | sed -e s/ANDcx556a/ANDnic_mellanox-cx556a/"
762     sed_nics_sub_cmd+=" | sed -e s/ANDvic1227/ANDnic_cisco-vic-1227/"
763     sed_nics_sub_cmd+=" | sed -e s/ANDvic1385/ANDnic_cisco-vic-1385/"
764     # Tag file directory shorthand.
765     tfd="${BASH_FUNCTION_DIR}"
766     case "${TEST_CODE}" in
767         # Select specific performance tests based on jenkins job type variable.
768         *"ndrpdr-weekly"* )
769             readarray -t test_tag_array < "${tfd}/mlr-weekly.txt" || die
770             ;;
771         *"mrr-daily"* )
772             readarray -t test_tag_array <<< $(sed 's/ //g' \
773                 ${tfd}/mrr-daily-${NODENESS}-${FLAVOR}.txt |
774                 eval ${sed_nics_sub_cmd}) || die
775             ;;
776         *"mrr-weekly"* )
777             readarray -t test_tag_array <<< $(${sed_nic_sub_cmd} \
778                 ${tfd}/mrr-weekly.txt) || die
779             ;;
780         * )
781             if [[ -z "${TEST_TAG_STRING-}" ]]; then
782                 # If nothing is specified, we will run pre-selected tests by
783                 # following tags.
784                 test_tag_array=("mrrAND${default_nic}AND1cAND64bANDip4base"
785                                 "mrrAND${default_nic}AND1cAND78bANDip6base"
786                                 "mrrAND${default_nic}AND1cAND64bANDl2bdbase"
787                                 "mrrAND${default_nic}AND1cAND64bANDl2xcbase"
788                                 "!dot1q" "!drv_avf")
789             else
790                 # If trigger contains tags, split them into array.
791                 test_tag_array=(${TEST_TAG_STRING//:/ })
792             fi
793             ;;
794     esac
795
796     # Blacklisting certain tags per topology.
797     #
798     # Reasons for blacklisting:
799     # - ipsechw - Blacklisted on testbeds without crypto hardware accelerator.
800     # TODO: Add missing reasons here (if general) or where used (if specific).
801     case "${TEST_CODE}" in
802         *"2n-skx"*)
803             test_tag_array+=("!ipsechw")
804             ;;
805         *"3n-skx"*)
806             test_tag_array+=("!ipsechw")
807             # Not enough nic_intel-xxv710 to support double link tests.
808             test_tag_array+=("!3_node_double_link_topoANDnic_intel-xxv710")
809             ;;
810         *"2n-clx"*)
811             test_tag_array+=("!ipsechw")
812             ;;
813         *"2n-dnv"*)
814             test_tag_array+=("!ipsechw")
815             test_tag_array+=("!memif")
816             test_tag_array+=("!srv6_proxy")
817             test_tag_array+=("!vhost")
818             test_tag_array+=("!vts")
819             test_tag_array+=("!drv_avf")
820             ;;
821         *"3n-dnv"*)
822             test_tag_array+=("!memif")
823             test_tag_array+=("!srv6_proxy")
824             test_tag_array+=("!vhost")
825             test_tag_array+=("!vts")
826             test_tag_array+=("!drv_avf")
827             ;;
828         *"3n-tsh"*)
829             # 3n-tsh only has x520 NICs which don't work with AVF
830             test_tag_array+=("!drv_avf")
831             test_tag_array+=("!ipsechw")
832             ;;
833         *"3n-hsw"*)
834             # TODO: Introduce NOIOMMU version of AVF tests.
835             # TODO: Make (both) AVF tests work on Haswell,
836             # or document why (some of) it is not possible.
837             # https://github.com/FDio/vpp/blob/master/src/plugins/avf/README.md
838             test_tag_array+=("!drv_avf")
839             # All cards have access to QAT. But only one card (xl710)
840             # resides in same NUMA as QAT. Other cards must go over QPI
841             # which we do not want to even run.
842             test_tag_array+=("!ipsechwNOTnic_intel-xl710")
843             ;;
844         *)
845             # Default to 3n-hsw due to compatibility.
846             test_tag_array+=("!drv_avf")
847             test_tag_array+=("!ipsechwNOTnic_intel-xl710")
848             ;;
849     esac
850
851     # We will add excluded NICs.
852     test_tag_array+=("${exclude_nics[@]/#/!NIC_}")
853
854     TAGS=()
855
856     # We will prefix with perftest to prevent running other tests
857     # (e.g. Functional).
858     prefix="perftestAND"
859     set +x
860     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
861         # Automatic prefixing for VPP jobs to limit the NIC used and
862         # traffic evaluation to MRR.
863         if [[ "${TEST_TAG_STRING-}" == *"nic_"* ]]; then
864             prefix="${prefix}mrrAND"
865         else
866             prefix="${prefix}mrrAND${default_nic}AND"
867         fi
868     fi
869     for tag in "${test_tag_array[@]}"; do
870         if [[ "${tag}" == "!"* ]]; then
871             # Exclude tags are not prefixed.
872             TAGS+=("${tag}")
873         elif [[ "${tag}" == " "* || "${tag}" == *"perftest"* ]]; then
874             # Badly formed tag expressions can trigger way too much tests.
875             set -x
876             warn "The following tag expression hints at bad trigger: ${tag}"
877             warn "Possible cause: Multiple triggers in a single comment."
878             die "Aborting to avoid triggering too many tests."
879         elif [[ "${tag}" != "" && "${tag}" != "#"* ]]; then
880             # Empty and comment lines are skipped.
881             # Other lines are normal tags, they are to be prefixed.
882             TAGS+=("${prefix}${tag}")
883         fi
884     done
885     set -x
886 }
887
888
889 function select_topology () {
890
891     # Variables read:
892     # - NODENESS - Node multiplicity of testbed, either "2n" or "3n".
893     # - FLAVOR - Node flavor string, currently either "hsw" or "skx".
894     # - CSIT_DIR - Path to existing root of local CSIT git repository.
895     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
896     # Variables set:
897     # - TOPOLOGIES - Array of paths to suitable topology yaml files.
898     # - TOPOLOGIES_TAGS - Tag expression selecting tests for the topology.
899     # Functions called:
900     # - die - Print to stderr and exit.
901
902     set -exuo pipefail
903
904     case_text="${NODENESS}_${FLAVOR}"
905     case "${case_text}" in
906         # TODO: Move tags to "# Blacklisting certain tags per topology" section.
907         # TODO: Double link availability depends on NIC used.
908         "1n_vbox")
909             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
910             TOPOLOGIES_TAGS="2_node_single_link_topo"
911             ;;
912         "1n_skx" | "1n_tx2")
913             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
914             TOPOLOGIES_TAGS="2_node_single_link_topo"
915             ;;
916         "2n_skx")
917             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_skx*.yaml )
918             TOPOLOGIES_TAGS="2_node_*_link_topo"
919             ;;
920         "3n_skx")
921             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_skx*.yaml )
922             TOPOLOGIES_TAGS="3_node_*_link_topo"
923             ;;
924         "2n_clx")
925             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_clx*.yaml )
926             TOPOLOGIES_TAGS="2_node_*_link_topo"
927             ;;
928         "2n_dnv")
929             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_dnv*.yaml )
930             TOPOLOGIES_TAGS="2_node_single_link_topo"
931             ;;
932         "3n_dnv")
933             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_dnv*.yaml )
934             TOPOLOGIES_TAGS="3_node_single_link_topo"
935             ;;
936         "3n_hsw")
937             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_hsw*.yaml )
938             TOPOLOGIES_TAGS="3_node_single_link_topo"
939             ;;
940         "3n_tsh")
941             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_tsh*.yaml )
942             TOPOLOGIES_TAGS="3_node_single_link_topo"
943             ;;
944         *)
945             # No falling back to 3n_hsw default, that should have been done
946             # by the function which has set NODENESS and FLAVOR.
947             die "Unknown specification: ${case_text}"
948     esac
949
950     if [[ -z "${TOPOLOGIES-}" ]]; then
951         die "No applicable topology found!"
952     fi
953 }
954
955
956 function select_vpp_device_tags () {
957
958     # Variables read:
959     # - TEST_CODE - String affecting test selection, usually jenkins job name.
960     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
961     #   Can be unset.
962     # Variables set:
963     # - TAGS - Array of processed tag boolean expressions.
964
965     set -exuo pipefail
966
967     case "${TEST_CODE}" in
968         # Select specific device tests based on jenkins job type variable.
969         * )
970             if [[ -z "${TEST_TAG_STRING-}" ]]; then
971                 # If nothing is specified, we will run pre-selected tests by
972                 # following tags. Items of array will be concatenated by OR
973                 # in Robot Framework.
974                 test_tag_array=()
975             else
976                 # If trigger contains tags, split them into array.
977                 test_tag_array=(${TEST_TAG_STRING//:/ })
978             fi
979             ;;
980     esac
981
982     # Blacklisting certain tags per topology.
983     #
984     # Reasons for blacklisting:
985     # - avf - AVF is not possible to run on enic driver of VirtualBox.
986     # - vhost - VirtualBox does not support nesting virtualization on Intel CPU.
987     case "${TEST_CODE}" in
988         *"1n-vbox"*)
989             test_tag_array+=("!avf")
990             test_tag_array+=("!vhost")
991             ;;
992         *)
993             ;;
994     esac
995
996     TAGS=()
997
998     # We will prefix with devicetest to prevent running other tests
999     # (e.g. Functional).
1000     prefix="devicetestAND"
1001     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
1002         # Automatic prefixing for VPP jobs to limit testing.
1003         prefix="${prefix}"
1004     fi
1005     for tag in "${test_tag_array[@]}"; do
1006         if [[ ${tag} == "!"* ]]; then
1007             # Exclude tags are not prefixed.
1008             TAGS+=("${tag}")
1009         else
1010             TAGS+=("${prefix}${tag}")
1011         fi
1012     done
1013 }
1014
1015 function untrap_and_unreserve_testbed () {
1016
1017     # Use this as a trap function to ensure testbed does not remain reserved.
1018     # Perhaps call directly before script exit, to free testbed for other jobs.
1019     # This function is smart enough to avoid multiple unreservations (so safe).
1020     # Topo cleanup is executed (call it best practice), ignoring failures.
1021     #
1022     # Hardcoded values:
1023     # - default message to die with if testbed might remain reserved.
1024     # Arguments:
1025     # - ${1} - Message to die with if unreservation fails. Default hardcoded.
1026     # Variables read (by inner function):
1027     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
1028     # - PYTHON_SCRIPTS_DIR - Path to directory holding Python scripts.
1029     # Variables written:
1030     # - WORKING_TOPOLOGY - Set to empty string on successful unreservation.
1031     # Trap unregistered:
1032     # - EXIT - Failure to untrap is reported, but ignored otherwise.
1033     # Functions called:
1034     # - die - Print to stderr and exit.
1035     # - ansible_hosts - Perform an action using ansible, see ansible.sh
1036
1037     set -xo pipefail
1038     set +eu  # We do not want to exit early in a "teardown" function.
1039     trap - EXIT || echo "Trap deactivation failed, continuing anyway."
1040     wt="${WORKING_TOPOLOGY}"  # Just to avoid too long lines.
1041     if [[ -z "${wt-}" ]]; then
1042         set -eu
1043         warn "Testbed looks unreserved already. Trap removal failed before?"
1044     else
1045         ansible_hosts "cleanup" || true
1046         python3 "${PYTHON_SCRIPTS_DIR}/topo_reservation.py" -c -t "${wt}" || {
1047             die "${1:-FAILED TO UNRESERVE, FIX MANUALLY.}" 2
1048         }
1049         WORKING_TOPOLOGY=""
1050         set -eu
1051     fi
1052 }
1053
1054
1055 function warn () {
1056
1057     # Print the message to standard error.
1058     #
1059     # Arguments:
1060     # - ${@} - The text of the message.
1061
1062     set -exuo pipefail
1063
1064     echo "$@" >&2
1065 }